=== debian/changelog ===
ospray (3.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1039111)

 -- Francois Mazen <mzf@debian.org>  Sun, 23 Jun 2024 18:24:44 +0200
