=== debian/control ===
Source: ospray
Section: graphics
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Francois Mazen <mzf@debian.org>
Architecture: amd64 arm64
Build-Depends: debhelper-compat (= 13),
               cmake,
               librkcommon-dev,
               libembree-dev,
               libbenchmark-dev,
               libgtest-dev,
               libispcrt-dev
Standards-Version: 4.6.2
Homepage: https://www.ospray.org
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/ospray
Vcs-Git: https://salsa.debian.org/science-team/ospray.git

Package: libospray3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: open source, scalable, and portable ray tracing engine library
 Intel® OSPRay is an open source, scalable, and portable ray tracing engine
 for high-performance, high-fidelity visualization on Intel Architecture
 CPUs, Intel Xe GPUs, and ARM64 CPUs.
 .
 This package contains the OSPRay library for running programs that use OSPRay

Package: libospray-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libospray3 (= ${binary:Version}),
         libembree-dev,
         librkcommon-dev
Description: OSPRay library development files
 Intel® OSPRay is an open source, scalable, and portable ray tracing engine
 for high-performance, high-fidelity visualization on Intel Architecture
 CPUs, Intel Xe GPUs, and ARM64 CPUs.
 .
 This package contains the headers library for building programs that
 use the OSPRay at runtime.
